
#include "accounthelper.h"
#include "../data/apirequest.h"
#include "../helpers/apihelper.h"

AccountHelper::AccountHelper(QObject *parent) : QObject(parent)
{
    mAPIHelper = new APIHelper;
}

bool AccountHelper::signedIn()
{
    return false; //TODO : implement
}

void AccountHelper::login(const AccountLoginRequest &info)
{
    //Create API request
    APIRequest *request = new APIRequest;
    request->setURI("account/login");
    request->addString("userMail", info.emailAddress());
    request->addString("userPassword", info.password());

    //Make connections
    connect(request, &APIRequest::success, this, &AccountHelper::requestLoginResult);
    connect(request, &APIRequest::error, this, &AccountHelper::loginError);

    //Execute request
    mAPIHelper->execute(request);

}

void AccountHelper::loginError(int code)
{
    //Delete API request
    qobject_cast<APIRequest *>(sender())->deleteLater();

    LoginResult result = LoginResult::OTHER_ERROR;

    if(code < 100)
        result = LoginResult::NETWORK_ERROR;
    if(code == 401)
        result = LoginResult::INVALID_CREDENTIALS;
    if(code == 429)
        result = LoginResult::TOO_MANY_REQUEST;

    //Inform about the result
    emit loginResult(result);
}

void AccountHelper::requestLoginResult(const QJsonDocument &document)
{
    //Delete API request
    qobject_cast<APIRequest *>(sender())->deleteLater();



    //Success
    emit loginResult(LoginResult::LOGIN_SUCCESS);
}
